import Header from "./components/Header";
import Footer from "./components/Footer";
import List from "./components/List";
import React, { Component } from "react";
export default class App extends Component {
  //维护一个任务列表
  state = {
    toDoList: [
      { id: 0, name: "吃饭", done: false },
      { id: 1, name: "睡觉", done: false },
      { id: 2, name: "打代码", done: false },
      { id: 3, name: "baibai", done: true },
    ],
  };
  addToDo = (valObj) => {
    try {
      //防止重复
      this.state.toDoList.forEach((item) => {
        if (item.name === valObj.name) {
          throw new Error("输入重复！");
        }
      });
      //更新state
      this.setState({
        toDoList: [
          {
            name: valObj.name,
            done: valObj.done,
            id: this.state.toDoList.length + 1,
          },
          ...this.state.toDoList,
        ],
      });
    } catch (e) {
      alert(e.message);
    }
  };
  //删除ToDo
  delToDo = (id) => {
    this.setState({
      toDoList: this.state.toDoList.filter((item) => {
        return item.id !== id;
      }),
    });
  };
  //统计完成的数量
  countDone = () => {
    let count = 0;
    this.state.toDoList.forEach((item) => {
      return item.done ? count++ : "";
    });
    return count;
  };
  //切换完成与未完成
  toggleDone = (id, isDone) => {
    this.setState({
      toDoList: this.state.toDoList.map((item) => {
        if (item.id === id) {
          item.id = id;
          item.done = isDone;
          return item;
        }
        return item;
      }),
    });
  };
  //全选与反选
  toggleSelect = (flag) => {
    this.setState({
      toDoList: this.state.toDoList.map((item) => {
        item.done = flag;
        return item;
      }),
    });
  };
  //删除选中
  delSelected = () => {
    this.setState({
      toDoList: this.state.toDoList.filter((item) => {
        return item.done === false;
      }),
    });
  };
  render() {
    return (
      <div className="body">
        <Header onAdd={this.addToDo}></Header>
        {/* props传值 */}
        <List
          list={this.state.toDoList}
          onDel={this.delToDo}
          toggleDone={this.toggleDone}
        ></List>
        <Footer
          allCount={this.state.toDoList.length}
          doneCount={this.countDone()}
          toggleSelect={this.toggleSelect}
          onClickDelSelect={this.delSelected}
        ></Footer>
      </div>
    );
  }
}
