import React, { Component } from "react";
import footer from "./index.module.css";
class Footer extends Component {
  state = {
    isAllChecked: false,
  };
  changeAllChecked = (e) => {
    const flag = e.target.checked;
    if (flag) {
      //全选
      this.props.toggleSelect(flag);
    } else {
      this.props.toggleSelect(flag);
    }
  };
  //可以在组件更新之前判断是否全选
  static getDerivedStateFromProps(props, state) {
    state.isAllChecked = props.doneCount === props.allCount ? true : false;
    return state;
  }
  render() {
    return (
      <div>
        <div className={`checkbox ${footer.box}`}>
          <label>
            <input
              type="checkbox"
              checked={this.state.isAllChecked && this.props.allCount}
              onChange={this.changeAllChecked}
            />
            <span className={footer.status}>
              已完成{this.props.doneCount} / 全部{this.props.allCount}
            </span>
          </label>
          <button
            onClick={() => {
              this.props.onClickDelSelect();
            }}
            type="button"
            className={`btn btn-danger button `}
          >
            删除选中
          </button>
        </div>
      </div>
    );
  }
}

export default Footer;
